import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.io.BufferedWriter;
import java.io.Writer;
import java.io.OutputStreamWriter;
import java.util.InputMismatchException;
import java.io.IOException;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author lewin
 */
public class xor_partition_lewin_brute {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        OutputWriter out = new OutputWriter(outputStream);
        XorParititonBrute solver = new XorParititonBrute();
        solver.solve(1, in, out);
        out.close();
    }

    static class XorParititonBrute {
        int n;
        int m;
        int[] x;
        int[] p;
        boolean[] used;
        int ans = 0;

        int[] generate(int[] x) {
            int[] p = new int[1 << m];
            for (int i = 0; i < p.length; i++) {
                p[i] = 0;
                for (int j = 1; j < x.length; j++) {
                    if ((x[p[i]] ^ i) < (x[j] ^ i)) {
                        p[i] = j;
                    }
                }
                p[i]++;
            }
            return p;
        }

        void dfs(int idx) {
            if (idx == n) {
                if (Arrays.equals(generate(x), p)) {
                    ans++;
                }
                return;
            }
            for (int i = 0; i < 1 << m; i++) {
                if (used[i]) continue;
                used[i] = true;
                x[idx] = i;
                dfs(idx + 1);
                used[i] = false;
            }
        }

        public void solve(int testNumber, InputReader in, OutputWriter out) {
            m = in.nextInt();
            n = in.nextInt();
            p = in.readIntArray(1 << m);
            x = new int[n];
            used = new boolean[1 << m];
            dfs(0);
            out.println(ans);
        }

    }

    static class OutputWriter {
        private final PrintWriter writer;

        public OutputWriter(OutputStream outputStream) {
            writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
        }

        public OutputWriter(Writer writer) {
            this.writer = new PrintWriter(writer);
        }

        public void close() {
            writer.close();
        }

        public void println(int i) {
            writer.println(i);
        }

    }

    static class InputReader {
        private InputStream stream;
        private byte[] buf = new byte[1 << 16];
        private int curChar;
        private int numChars;

        public InputReader(InputStream stream) {
            this.stream = stream;
        }

        public int[] readIntArray(int tokens) {
            int[] ret = new int[tokens];
            for (int i = 0; i < tokens; i++) {
                ret[i] = nextInt();
            }
            return ret;
        }

        public int read() {
            if (this.numChars == -1) {
                throw new InputMismatchException();
            } else {
                if (this.curChar >= this.numChars) {
                    this.curChar = 0;

                    try {
                        this.numChars = this.stream.read(this.buf);
                    } catch (IOException var2) {
                        throw new InputMismatchException();
                    }

                    if (this.numChars <= 0) {
                        return -1;
                    }
                }

                return this.buf[this.curChar++];
            }
        }

        public int nextInt() {
            int c;
            for (c = this.read(); isSpaceChar(c); c = this.read()) {
                ;
            }

            byte sgn = 1;
            if (c == 45) {
                sgn = -1;
                c = this.read();
            }

            int res = 0;

            while (c >= 48 && c <= 57) {
                res *= 10;
                res += c - 48;
                c = this.read();
                if (isSpaceChar(c)) {
                    return res * sgn;
                }
            }

            throw new InputMismatchException();
        }

        public static boolean isSpaceChar(int c) {
            return c == 32 || c == 10 || c == 13 || c == 9 || c == -1;
        }

    }
}

